import {
  Action,
} from './action';
import {
  ConstructorType,
  Metadata,
  TypeUtil,
} from '@overflow/commons/core/type';
import {
  ActionMappingAnnotation,
  ActionMappingMetadataKey,
  ReducerMetadataKey,
  ReducerAnnotation,
} from '@overflow/commons/redux/decorators';

export default class LPCReducer {

  private reducerMap: Map<string, any[]>;

  protected constructor() {
    this.reducerMap = new Map();
  }

  public reducer<State>(state: State, action: Action): State {
    // let rm: string[] = action.type.split('.');
    // if (null == rm || 2 !== rm.length) {
    //   console.log(`Method[${action.type}] is not valid.`);
    //   return null;
    // }

    // const reducerName: string = rm[0];
    // const methodName: string = rm[1];

    // if (this.reducerMap.has(reducerName)) {
    //   let reducers = this.reducerMap.get(reducerName);
    //   for (let reducer of reducers) {

    //     state = reducer(state, action);
    //   }
    // }

    return state;
  }

  /**
   * registerReducers
   */
  public registerReducers(reducerTypes: ConstructorType[]): void {
    for (let reducerType of reducerTypes) {
      let ra: ReducerAnnotation = Metadata.get(ReducerMetadataKey, reducerType);
      if (undefined === ra) {
        continue;
      }
      console.log(`name: ${ra.attributes.name}`);
      let ama: ActionMappingAnnotation = Metadata.get(ActionMappingMetadataKey, reducerType);
      if (undefined === ama) {
        continue;
      }
      console.log(`actionMapping-value: ${ama.attributes.value}`);

      let properties = Object.keys(reducerType.prototype);
      for (let propertyKey of properties) {
        if (!TypeUtil.isMethod(reducerType.prototype, propertyKey)) {
          console.log(`property: ${propertyKey}`);
          continue;
        }
        console.log(`method: ${propertyKey}`);
      }
    }

  }

  /**
   * registerReducer
   */
  public registerReducer(reducerType: ConstructorType): void {
    console.log(``);

  }
}
